import pymongo
import pickle
import subprocess
import pprint

linkfilename = "link.txt"
outputfilename = "q2.pkl"
mongodbConfigFilename = "config-MongoDB.txt"
mongodbOutputFilename = "output-MongoDB.txt"

def obtainStudentList():
	print("start crawling the URLs specified in file: "+linkfilename)
	strCommand = "scrapy crawl q2 -a urlfile='"+linkfilename+"' -a outputfile='"+outputfilename+"'"
	subprocess.run(strCommand,shell=True)
	with open(outputfilename, 'rb') as f: 
		unpickle = pickle.Unpickler(f)
		stuList = unpickle.load()
	return stuList
# scrapy crawl q2 -a urlfile='link.txt' -a outputfile='q2.pkl'

def storeToMongoDB(datas):
	mongo_uri = ""
	mongo_db = ""
	with open(mongodbConfigFilename, 'r') as file: 
		lines = file.readlines()
		mongo_uri = str(lines[0].rstrip())
		mongo_db = str(lines[1].rstrip())
	print("mongo_uri: "+str(mongo_uri)+" mongo_db: "+str(mongo_db))
	try:
		client = pymongo.MongoClient(mongo_uri)
		db = client[mongo_db]
		for data in datas:
			data["chemistry"] = int(data["chemistry"])
			data["history"] = int(data["history"])
			data["computer"] = int(data["computer"])
			db.student.insert(data)
		print("Inserting Data is Successful!")

		db.student.remove({"computer":{"$lt":50}})
		print("Deleting Documents is Successful!")

		resultCursor = db.student.find({"chemistry":{"$gt":50}}).sort('sname')
		print("Obtaining Documents is Successful!")

		results = []
		for student in resultCursor:
			results.append(student)
		# print("results: ")
		# pprint.pprint(results)
		with open(mongodbOutputFilename, 'w') as file:
			file.write(str(len(results))+"\n")
			for student in results:
				file.write(student["sid"]+","+student["sname"]+","+str(student["chemistry"])+","+str(student["history"])+","+str(student["computer"])+"\n")
		print("Writing Documents is Successful!")
		db.student.drop()
		print("Dropping Collection is Successful!")
	except pymongo.errors.ConnectionFailure as error:
		print(error)
def main():
	print("start main")
	stuList = obtainStudentList()
	storeToMongoDB(stuList)
main()