import numpy
from keras.models import Sequential
from keras.layers import Dense
from keras.models import model_from_json

TRAIN_DATA_FILE_NAME="training.csv"
PREDICT_DATA_FILE_NAME = "new.csv"
OUTPUT_FILE_NAME = "output-NN.csv"
def trainData():
	datasetX = numpy.loadtxt(TRAIN_DATA_FILE_NAME,delimiter=",",dtype="float",usecols=range(0,2))
	datasetY = numpy.loadtxt(TRAIN_DATA_FILE_NAME,delimiter=",",dtype="str",usecols=[2])
	print(" datasetX: ")
	print(datasetX)
	print(" datasetY: ")
	print(datasetY)
	datasetY= list(map(lambda x: 1 if x=='Yes' else 0,datasetY))
	print(" datasetY transformed: ")
	print(datasetY)

	numpy.random.seed(4332)
	model = Sequential()
	model.add(Dense(2,input_dim=2, activation='relu'))
	model.add(Dense(4, activation='relu'))
	model.add(Dense(1, activation='sigmoid'))

	model.compile(loss="binary_crossentropy",optimizer="adam", metrics=["accuracy"])
	model.fit(datasetX, datasetY, validation_split=0.2, epochs=1500, batch_size=4)
	scores = model.evaluate(datasetX, datasetY)
	print("")
	print("{}: {}".format(model.metrics_names[1], scores[1]*100))

	return model

def predictData(model):
	newX = numpy.loadtxt(PREDICT_DATA_FILE_NAME,delimiter=",",dtype="float")
	print("")
	print(" newX: ")
	print(newX)
	newY = model.predict(newX)
	print("")
	print(" newY: ")
	print(newY)
	with open(OUTPUT_FILE_NAME, 'w') as file:
		for Y in newY:
			file.write(round(Y,10)+","+'No' if Y<0.5 else 'Yes'+"/n")
		


def main():
	model = trainData()
	predictData(model)
main()